﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Security.Permissions;
using System.Collections;
namespace TestACallFromDll
{

    [StructLayout(LayoutKind.Sequential)]
    public struct VARIANT
    {
        private ushort vt;
        public short wReserved1;
        public short wReserved2;
        public short wReserved3;
        public int Val1;
        public int Val2;
        public VarEnum Vt
        {
            get { return (VarEnum)vt; }
            set { vt = (ushort)value; }
        }

        [DllImport("oleaut32")]
        public extern static void VariantInit(ref VARIANT v);
        [DllImport("oleaut32")]
        public extern static void VariantClear(ref VARIANT v);
    };



   [StructLayout(LayoutKind.Sequential)]
    public struct segmentInfo_st
    {
        public int nSegID;
        public int nSegFillOrder;
        public int nSelectFlag;
        public int nGraficDispFlag;
        public int nImgTextDispFlag;
        public int nScalBarDispFlag;
        public int nShutterDispFlag;
        public int nSummaryFlag;
        public int nNoteFlag;
      //  public IntPtr segList;
    }
   
    public partial class Form1 : Form
    {

        [StructLayout(LayoutKind.Sequential)]
        public struct SystemTime
        {
            public ushort wYear;
            public ushort wMonth;
            public ushort wDay;
            public ushort wHour;
            public ushort wMin;
            public ushort wSec;
            public ushort wxx;
        }

        

      
        [DllImport("Kernel32.dll")]
        public static extern void GetSystemTime(ref SystemTime sysTime);
         [DllImport("TestOne.dll")]
       public static extern void  TestACallFromDll();
         [DllImport("TestOne.dll")]
         public static extern void TestAVarrient([MarshalAs(UnmanagedType.Struct)] object p, ref IntPtr res);
        [DllImport("user32.dll")]
        static extern int MessageBoxA(int hWnd,
                                      string strMsg,
                                      string strCaption,
                                      int iType);



        public Form1()
        {
            InitializeComponent();
        }
       // [SecurityPermissionAttribute(SecurityAction.LinkDemand, Flags = SecurityPermissionFlag.UnmanagedCode)]

        private void button1_Click(object sender, EventArgs e)
        {
            string csName ="";
            //TestACallFromDll();  
            SystemTime sysTime = new SystemTime();
            GetSystemTime(ref sysTime);            
            //IntPtr p = Marshal.AllocCoTaskMem(1000);
           
           // string s = "Dileep";
            //p = Marshal.StringToBSTR(s);
               //Marshal.GetNativeVariantForObject(s, p);

            //TestAVarrient(Marshal.StringToBSTR(s));

            //Marshal.Copy(
            segmentInfo_st segInfo = new segmentInfo_st();
            object ob = new object();
            segInfo.nSegID = 1;
            segInfo.nGraficDispFlag = 2;
            segInfo.nImgTextDispFlag = 0;
            segInfo.nNoteFlag = 9;
            segInfo.nScalBarDispFlag = 3;
            segInfo.nSummaryFlag = 6;          
            ob = segInfo;

            VariantWrapper p =new VariantWrapper (segInfo);

            //segInfo.segList = IntPtr.Zero;
            IntPtr ptrValue = Marshal.AllocHGlobal(Marshal.SizeOf(segInfo));// Marshal.AllocHGlobal(8192);
            //Marshal.AllocHGlobal(Marshal.SizeOf(segInfo));
            Marshal.StructureToPtr(segInfo, ptrValue, false);

            IntPtr res = Marshal.AllocCoTaskMem(1000);
            segmentInfo_st resInfo ;
            
            TestAVarrient(ptrValue,ref res);
            resInfo=(segmentInfo_st) Marshal.GetObjectForNativeVariant(res);
            Marshal.FreeHGlobal(ptrValue);

            
            NameText.Text = csName;
        }
    }
}
